# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_officeonlineserverfarm`](#dsc_officeonlineserverfarm): The DSC OfficeOnlineServerFarm resource type. Automatically generated from version 1.2.0.0
* [`dsc_officeonlineserverinstall`](#dsc_officeonlineserverinstall): The DSC OfficeOnlineServerInstall resource type. Automatically generated from version 1.2.0.0
* [`dsc_officeonlineserverinstalllanguagepack`](#dsc_officeonlineserverinstalllanguagepack): The DSC OfficeOnlineServerInstallLanguagePack resource type. Automatically generated from version 1.2.0.0
* [`dsc_officeonlineservermachine`](#dsc_officeonlineservermachine): The DSC OfficeOnlineServerMachine resource type. Automatically generated from version 1.2.0.0

## Resource types

### `dsc_officeonlineserverfarm`

The DSC OfficeOnlineServerFarm resource type.
Automatically generated from version 1.2.0.0

#### Properties

The following properties are available in the `dsc_officeonlineserverfarm` type.

##### `dsc_allowceip`

Data type: `Optional[Boolean]`

Enables Customer Experience Improvement Program (CEIP) reporting on all servers in the Office Web Apps Server farm

##### `dsc_allowhttp`

Data type: `Optional[Boolean]`

Indicates that IIS sites should be provisioned on port 80 for HTTP access. Use AllowHTTP only in environments where all computers require IPSEC (full encryption) or in test environments that do not contain sensitive files.

##### `dsc_allowhttpsecurestoreconnections`

Data type: `Optional[Boolean]`

Indicates that secure store connections can be made by using non-SSL connections (such as HTTP). The default is False.

##### `dsc_allowoutboundhttp`

Data type: `Optional[Boolean]`

 

##### `dsc_cachelocation`

Data type: `Optional[String]`

Specifies the location of the global disk cache that is used to store rendered image files.

##### `dsc_cachesizeingb`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum size of the global disk cache in gigabytes.

##### `dsc_certificatename`

Data type: `Optional[String]`

Specifies the friendly name of the certificate that Office Web Apps Server uses to create HTTPS bindings.

##### `dsc_clipartenabled`

Data type: `Optional[Boolean]`

Enables support for inserting clip art from Office.com into Office documents. This feature requires server-to-web communication, configured either directly or by using a proxy that you specify by using the Proxy parameter.

##### `dsc_documentinfocachesize`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum number of document conversion records that are stored in a memory cache.

##### `dsc_editingenabled`

Data type: `Optional[Boolean]`

Enables support for editing in the browser. The default is False. Only set to True if you have the appropriate licensing to use the editing functionality.

##### `dsc_excelabortonrefreshonopenfail`

Data type: `Optional[Boolean]`

Specifies that the loading of a Web Excel file automatically fails if an automatic data refresh operation fails when the file is opened.

##### `dsc_excelallowexternaldata`

Data type: `Optional[Boolean]`

Enables the refresh of supported external data in Excel Web App workbooks where workbooks contain connections to external data. The default is True.

##### `dsc_excelautomaticvolatilefunctioncachelifetime`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum time, in seconds, that a computed value for a volatile function is cached for automatic recalculations.

##### `dsc_excelcachingunusedfiles`

Data type: `Optional[Boolean]`

Enable caching of files that are no longer in use by Web Excel sessions.

##### `dsc_excelchartandimagesizemax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum size, in megabytes, of a chart or image that can be opened.

##### `dsc_excelconcurrentdatarequestspersessionmax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum number of concurrent external data requests allowed in each session. If a session must issue more than this number of requests, additional requests must be queued. The scope of this setting is the logical server.

##### `dsc_excelconnectionlifetime`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the duration, in seconds, of external data connections for Excel Web App. The default is 1800 seconds.

##### `dsc_exceldefaultworkbookcalcmode`

Data type: `Optional[String]`

Specifies the calculation mode of workbooks.  Settings other than File override the workbook settings.

##### `dsc_excelexternaldatacachelifetime`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifes the duration, in seconds, of the external data cache lifetime in Excel Web App. The default is 300 seconds.

##### `dsc_excelmemorycachethreshold`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The percentage of the Maximum Private Bytes that can be allocated to inactive objects. When the memory cache threshold is exceeded, cached objects that are not currently in use are released.

##### `dsc_excelprivatebytesmax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum private bytes, in megabytes, used by Excel Web App. When set to -1, the maximum private bytes use 50 percent of physical memory on the computer.

##### `dsc_excelrequestdurationmax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum duration, in seconds, for a single request in a session. After this time elapses, the request times out.

##### `dsc_excelrestexternaldataenabled`

Data type: `Optional[Boolean]`

Specifies whether requests from the Representational State Transfer (REST) Application Programming Interface (API) are permitted to refresh external data connections.

##### `dsc_excelsessiontimeout`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the time, in seconds, that a session remains active in Excel Web App when there is no user activity.

##### `dsc_exceludfsallowed`

Data type: `Optional[Boolean]`

Activates user-defined functions for use with Web Excel.

##### `dsc_excelunusedobjectagemax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The maximum time (in minutes) that inactive objects remain in the memory cache. Inactive objects are objects that are not used in a session.

##### `dsc_exceluseeffectiveusername`

Data type: `Optional[Boolean]`

 

##### `dsc_excelwarnondatarefresh`

Data type: `Optional[Boolean]`

Turns off or on the warning dialog displayed when data refreshes in Excel Web App.

##### `dsc_excelworkbooksizemax`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum size, in megabytes, of a workbook that can be loaded.

##### `dsc_externalurl`

Data type: `Optional[String]`

Specifies the URL root that clients use to access the Office Web Apps Server farm from the Internet. In the case of a load-balanced, multiserver Office Web Apps Server farm, the external URL is bound to the IP address of the external-facing load balancer.

##### `dsc_farmou`

Data type: `Optional[String]`

Specifies the name of the Active Directory organizational unit (OU) that servers must be a member of to join the Office Web Apps Server farm. Use this parameter to prevent unauthorized servers (that is, servers that are not in the OU) from joining an Office Web Apps Server farm.

##### `dsc_loglocation`

Data type: `Optional[String]`

Specifies the location on the local computer where activity logs are stored.

##### `dsc_logretentionindays`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the number of days that log entries are stored. Log entries older than the configured date are trimmed.

##### `dsc_logverbosity`

Data type: `Optional[String]`

Specifies how much information is stored in the trace log files.

##### `dsc_maxmemorycachesizeinmb`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies, in megabytes, the maximum amount of memory that the rendering cache can use.

##### `dsc_maxtranslationcharactercount`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the maximum amount of characters a document can have in order to be translated.

##### `dsc_openfromuncenabled`

Data type: `Optional[Boolean]`

Turns on or off the ability to use Online Viewers to view Office files from a UNC path.

##### `dsc_openfromurlenabled`

Data type: `Optional[Boolean]`

Turns on or off the ability to use Online Viewers to view Office files from a URL or UNC path.

##### `dsc_openfromurlthrottlingenabled`

Data type: `Optional[Boolean]`

Throttles the number of open from URL requests from any given server in a time period. The default throttling values, which are not configurable, make sure that an Office Web Apps Server farm will not overwhelm a single server with requests for content to be viewed in the Online Viewers.

##### `dsc_picturepastedisabled`

Data type: `Optional[Boolean]`

 

##### `dsc_proxy`

Data type: `Optional[String]`

Specifies the URL of the proxy server that is configured to allow HTTP requests to external sites. Typically configured in conjunction with the ClipartEnabled and TranslationEnabled parameters.

##### `dsc_recycleactiveprocesscount`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

Specifies the number of files that a single Word or PowerPoint process can render before the process is recycled.

##### `dsc_removepersonalinformationfromlogs`

Data type: `Optional[Boolean]`

 

##### `dsc_renderinglocalcachelocation`

Data type: `Optional[String]`

Specifies the location of the temporary cache for use by the Word and PowerPoint Viewing Services.

##### `dsc_s2scertificatename`

Data type: `Optional[String]`

 

##### `dsc_ssloffloaded`

Data type: `Optional[Boolean]`

Indicates to the servers in the Office Web Apps Server farm that SSL is offloaded to the load balancer. When SSLOffloaded is enabled, web applications are bound to port 80 (HTTP) on the local server. However, HTML that references other resources, such as CSS or images, uses HTTPS URLs for those references.

##### `dsc_translationenabled`

Data type: `Optional[Boolean]`

Enables support for automatic document translation using Microsoft Translator, an online service that translates text between languages. The translated file is shown in the Word Web App. Because Microsoft Translator is an online service, you must enable server-to-web communication directly or by using a proxy that you specify by using the Proxy parameter.

##### `dsc_translationserviceaddress`

Data type: `Optional[String]`

Specifies the URL of the translation server that translation requests are sent to. The default is the Microsoft Translator online service. Typically you will not use this parameter unless you must change translation services.

##### `dsc_translationserviceappid`

Data type: `Optional[String]`

Specifies the application ID for the translation service. The default is the public application ID for Office Web Apps. Typically you will not use this parameter unless you have negotiated with Microsoft Translator for additional services and they have provided you with a private application ID.

#### Parameters

The following parameters are available in the `dsc_officeonlineserverfarm` type.

##### `dsc_internalurl`

namevar

Data type: `String`

Specifies the URL root that clients use to access the Office Web Apps Server farm from the intranet.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_officeonlineserverinstall`

The DSC OfficeOnlineServerInstall resource type.
Automatically generated from version 1.2.0.0

#### Properties

The following properties are available in the `dsc_officeonlineserverinstall` type.

##### `dsc_path`

Data type: `String`

Path to setup.exe

#### Parameters

The following parameters are available in the `dsc_officeonlineserverinstall` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Set to 'present' to specificy that the product should be installed.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_officeonlineserverinstalllanguagepack`

The DSC OfficeOnlineServerInstallLanguagePack resource type.
Automatically generated from version 1.2.0.0

#### Properties

The following properties are available in the `dsc_officeonlineserverinstalllanguagepack` type.

##### `dsc_language`

Data type: `String`

Language code for the package

#### Parameters

The following parameters are available in the `dsc_officeonlineserverinstalllanguagepack` type.

##### `dsc_binarydir`

namevar

Data type: `String`

Path to setup.exe

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Set to 'present' to specificy that the product should be installed.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_officeonlineservermachine`

The DSC OfficeOnlineServerMachine resource type.
Automatically generated from version 1.2.0.0

#### Properties

The following properties are available in the `dsc_officeonlineservermachine` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure Present or Absent

##### `dsc_roles`

Data type: `Optional[Array[String]]`

Specifies one or more server roles, separated by commas, to assign to the new server. If no roles are specified, then the server is assigned all roles.

#### Parameters

The following parameters are available in the `dsc_officeonlineservermachine` type.

##### `dsc_machinetojoin`

namevar

Data type: `String`

Specifies the name of any server that is already a member of the Office Web Apps Server farm.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

