require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_officeonlineserverinstall',
  dscmeta_resource_friendly_name: 'OfficeOnlineServerInstall',
  dscmeta_resource_name: 'MSFT_OfficeOnlineServerInstall',
  dscmeta_module_name: 'OfficeOnlineServerDsc',
  dscmeta_module_version: '1.2.0.0',
  docs: 'The DSC OfficeOnlineServerInstall resource type.
         Automatically generated from version 1.2.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_path: {
      type: 'String',
      desc: 'Path to setup.exe',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Enum['Present', 'Absent']",
      desc: "Set to 'present' to specificy that the product should be installed.",
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
