require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_officeonlineservermachine',
  dscmeta_resource_friendly_name: 'OfficeOnlineServerMachine',
  dscmeta_resource_name: 'MSFT_OfficeOnlineServerMachine',
  dscmeta_module_name: 'OfficeOnlineServerDsc',
  dscmeta_module_version: '1.2.0.0',
  docs: 'The DSC OfficeOnlineServerMachine resource type.
         Automatically generated from version 1.2.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_roles: {
      type: 'Optional[Array[String]]',
      desc: 'Specifies one or more server roles, separated by commas, to assign to the new server. If no roles are specified, then the server is assigned all roles.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_machinetojoin: {
      type: 'String',
      desc: 'Specifies the name of any server that is already a member of the Office Web Apps Server farm.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Ensure Present or Absent',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
